﻿using System;

namespace GameUtils.Input
{
    public abstract class InputDevice<TState> : IInputProvider<TState>
    {
        bool IEngineComponent.IsCompatibleTo(IEngineComponent component)
        {
            return true;
        }

        public object Tag { get; set; }

        public abstract ListenerHandle<TState> RegisterListener(IInputListener<TState> listener);

        public abstract void Initialize(System.Windows.Forms.Control surface);

        public abstract void BeginCapture();

        public abstract void EndCapture();

        private bool disposed;

        public void Dispose()
        {
            if (!disposed)
            {
                Dispose(true);
                GC.SuppressFinalize(this);

                disposed = true;
            }
        }

        protected virtual void Dispose(bool disposing) { }

        ~InputDevice()
        {
            Dispose(false);
        }
    }
}
