﻿using GameUtils.Graphics;
using GameUtils.Graphics.Data;
using GameUtils.Math;
using SharpDX.Direct2D1;
using SolidColorBrush = SharpDX.Direct2D1.SolidColorBrush;

namespace GameUtils.Renderers.Direct2D1
{
    internal class Direct2DSolidColorBrush : SolidColorBrushData, IDirect2DBrush
    {
        readonly SolidColorBrush brush;

        public Brush Brush
        {
            get { return brush; }
        }

        protected override Color4 Color
        {
            get { return Direct2DHelper.D2DColorToGraphicsColor(brush.Color); }
            set { brush.Color = Direct2DHelper.GraphicsColorToD2DColor(value); }
        }

        protected override float Opacity
        {
            get {  return brush.Opacity; }
            set { brush.Opacity = value; }
        }

        internal Direct2DSolidColorBrush(RenderTarget target, Color4 color)
        {
            brush = new SolidColorBrush(target, Direct2DHelper.GraphicsColorToD2DColor(color));
        }

        protected override void SetTransform(Matrix2x3 matrix)
        { }

        protected override void ResetTransform()
        { }

        protected override void Dispose(bool disposing)
        {
            brush.Dispose();
        }
    }
}
