﻿using GameUtils.Graphics;
using GameUtils.Graphics.Data;
using SharpDX.Direct2D1;
using D2D = SharpDX.Direct2D1;

namespace GameUtils.Renderers.Direct2D1_1
{
    internal class Direct2DSolidColorBrush : SolidColorBrushData, IDirect2DBrush
    {
        readonly D2D.SolidColorBrush brush;

        public Brush Brush
        {
            get { return brush; }
        }

        protected override Color4 Color
        {
            get { return Direct2DHelper.D2DColorToGraphicsColor(brush.Color); }
            set { brush.Color = Direct2DHelper.GraphicsColorToD2DColor(value); }
        }

        protected override float Opacity
        {
            get {  return brush.Opacity; }
            set { brush.Opacity = value; }
        }

        internal Direct2DSolidColorBrush(RenderTarget target, Color4 color)
        {
            brush = new D2D.SolidColorBrush(target, Direct2DHelper.GraphicsColorToD2DColor(color));
        }

        protected override void SetTransform(Math.Matrix2x3 matrix)
        { }

        protected override void ResetTransform()
        { }

        protected override void Dispose(bool disposing)
        {
            brush.Dispose();
        }
    }
}
